# Format

This package offers Python-style general formatting and c-style numerical formatting (for speed).

[pkg-url]: https://github.com/JuliaString/Format.jl.git

[julia-url]:    https://github.com/JuliaLang/Julia
[julia-release]:https://img.shields.io/github/release/JuliaLang/julia.svg

[release]:      https://img.shields.io/github/release/JuliaString/Format.jl.svg
[release-date]: https://img.shields.io/github/release-date/JuliaString/Format.jl.svg

[license-img]:  http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat
[license-url]:  LICENSE.md

[gitter-img]:   https://badges.gitter.im/Join%20Chat.svg
[gitter-url]:   https://gitter.im/JuliaString/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge

[travis-url]:   https://travis-ci.org/JuliaString/Format.jl
[travis-s-img]: https://travis-ci.org/JuliaString/Format.jl.svg
[travis-m-img]: https://travis-ci.org/JuliaString/Format.jl.svg?branch=master

[codecov-url]:  https://codecov.io/gh/JuliaString/Format.jl
[codecov-img]:  https://codecov.io/gh/JuliaString/Format.jl/branch/master/graph/badge.svg

[contrib]:    https://img.shields.io/badge/contributions-welcome-brightgreen.svg?style=flat

[![][release]][pkg-url] [![][release-date]][pkg-url] [![][license-img]][license-url] [![contributions welcome][contrib]](https://github.com/JuliaString/Format.jl/issues)

| **Julia Version** | **Unit Tests** | **Coverage** |
|:------------------:|:------------------:|:---------------------:|
| [![][julia-release]][julia-url] | [![][travis-s-img]][travis-url] | [![][codecov-img]][codecov-url]
| Julia Latest | [![][travis-m-img]][travis-url] | [![][codecov-img]][codecov-url]

## Getting Started

This package is pure Julia. Setting up this package is like setting up other Julia packages:

```julia
Pkg.add("Format")
```
or
```julia
]add Format
```

It is forked off of [Formatting.jl](https://github.com/JuliaIO/Formatting.jl), and I try to keep the oldmaster branch up to date with the master branch of that, and cherry pick or port all necessary changes to `Format`).

To start using the package, you can simply write

```julia
using Format
```

This package depends on Julia of version 1.4 or above, and. The package is MIT-licensed.


## Python-style Types and Functions

#### Types to Represent Formats

This package has two types ``FormatSpec`` and ``FormatExpr`` to represent a format specification.

In particular, ``FormatSpec`` is used to capture the specification of a single entry. One can compile a format specification string into a ``FormatSpec`` instance as

```julia
fspec = FormatSpec("d")
fspec = FormatSpec("<8.4f")
```
Please refer to [Python's format specification language](http://docs.python.org/2/library/string.html#formatspec) for details.


``FormatExpr`` captures a formatting expression that may involve multiple items. One can compile a formatting string into a ``FormatExpr`` instance as

```julia
fe = FormatExpr("{1} + {2}")
fe = FormatExpr("{1:d} + {2:08.4e} + {3|>abs2}")
```
Please refer to [Python's format string syntax](http://docs.python.org/2/library/string.html#format-string-syntax) for details.


**Note:** If the same format is going to be applied for multiple times. It is more efficient to first compile it.


#### Formatted Printing

One can use ``printfmt`` and ``printfmtln`` for formatted printing:

- **printfmt**(io, fe, args...)

- **printfmt**(fe, args...)

    Print given arguments using given format ``fe``. Here ``fe`` can be a formatting string, an instance of ``FormatSpec`` or ``FormatExpr``.
    
    **Examples**
    
    ```julia
    printfmt("{1:>4s} + {2:.2f}", "abc", 12) # --> print(" abc + 12.00")
    printfmt("{} = {:#04x}", "abc", 12) # --> print("abc = 0x0c") 
    
    fs = FormatSpec("#04x")
    printfmt(fs, 12)   # --> print("0x0c")
    
    fe = FormatExpr("{} = {:#04x}")
    printfmt(fe, "abc", 12)   # --> print("abc = 0x0c")
    ```

    **Notes**

    If the first argument is a string, it will be first compiled into a ``FormatExpr``, which implies that you can not use specification-only string in the first argument.

    ```julia
    printfmt("{1:d}", 10)   # OK, "{1:d}" can be compiled into a FormatExpr instance
    printfmt("d", 10)       # Error, "d" can not be compiled into a FormatExpr instance
                            # such a string to specify a format specification for single argument

    printfmt(FormatSpec("d"), 10)  # OK
    printfmt(FormatExpr("{1:d}", 10)) # OK
    ```


- **printfmtln**(io, fe, args...)

- **printfmtln**(fe, args...)

    Similar to ``printfmt`` except that this function print a newline at the end.

#### Formatted String

One can use ``pyfmt`` to format a single value into a string, or ``format`` to format one to multiple arguments into a string using an format expression.

- **pyfmt**(fspec, a)

    Format a single value using a format specification given by ``fspec``, where ``fspec`` can be either a string or an instance of ``FormatSpec``.

- **format**(fe, args...)

    Format arguments using a format expression given by ``fe``, where ``fe`` can be either a string or an instance of ``FormatSpec``.


#### Difference from Python's Format

At this point, this package implements a subset of Python's formatting language (with slight modification). Here is a summary of the differences:

- In terms of argument specification, it supports natural ordering (e.g. ``{} + {}``), explicit position (e.g. ``{1} + {2}``). It hasn't supported named arguments or fields extraction yet. Note that mixing these two modes is not allowed (e.g. ``{1} + {}``).

- The package provides support for filtering (for explicitly positioned arguments), such as ``{1|>lowercase}`` by allowing one to embed the ``|>`` operator, which the Python counter part does not support.

## C-style functions

The c-style part of this package aims to get around the limitation that
`@sprintf` has to take a literal string argument.
The core part is basically a c-style print formatter using the standard
`@sprintf` macro.
It also adds functionalities such as commas separator (thousands), parenthesis for negatives,
stripping trailing zeros, and mixed fractions.

### Usage and Implementation

The idea here is that the package compiles a function only once for each unique
format string within the `Format.*` name space, so repeated use is faster.
Unrelated parts of a session using the same format string would reuse the same
function, avoiding redundant compilation. To avoid the proliferation of
functions, we limit the usage to only 1 argument. Practical consideration
would suggest that only dozens of functions would be created in a session, which
seems manageable.

Usage
```julia
using Format

fmt = "%10.3f"
s = cfmt( fmt, 3.14159 ) # usage 1. Quite performant. Easiest to switch to.

fmtrfunc = generate_formatter( fmt ) # usage 2. This bypass repeated lookup of cached function. Most performant.
s = fmtrfunc( 3.14159 )

s = format( 3.14159, precision=3 ) # usage 3. Most flexible, with some non-printf options. Least performant.
```

### Commas

This package also supplements the lack of thousand separator e.g. `"%'d"`, `"%'f"`, `"%'g"`.

Note: `"%'g"` behavior is that for small enough floating point (but not too small),
thousand separator would be used. If the number needs to be represented by `"%e"`, no
separator is used.

### Flexible `format` function

This package contains a run-time number formatter `format` function, which goes beyond
the standard `sprintf` functionality.

An example:
```julia
s = format( 1234, commas=true ) # 1,234
s = format( -1234, commas=true, parens=true ) # (1,234)
```

The keyword arguments are (Bold keywords are not printf standard)

* width. Integer. Try to fit the output into this many characters. May not be successful.
   Sacrifice space first, then commas.
* precision. Integer. How many decimal places.
* leftjustified. Boolean
* zeropadding. Boolean
* commas. Boolean. Thousands-group separator.
* signed. Boolean. Always show +/- sign?
* positivespace. Boolean. Prepend an extra space for positive numbers? (so they align nicely with negative numbers)
* **parens**. Boolean. Use parenthesis instead of "-". e.g. `(1.01)` instead of `-1.01`. Useful in finance. Note that
  you cannot use `signed` and `parens` option at the same time.
* **stripzeros**. Boolean. Strip trailing '0' to the right of the decimal (and to the left of 'e', if any ).
   * It may strip the decimal point itself if all trailing places are zeros.
   * This is true by default if precision is not given, and vice versa.
* alternative. Boolean. See `#` alternative form explanation in standard printf documentation
* conversion. length=1 string. Default is type dependent. It can be one of `aAeEfFoxX`. See standard
  printf documentation.
* **mixedfraction**. Boolean. If the number is rational, format it in mixed fraction e.g. `1_1/2` instead of `3/2`
* **mixedfractionsep**. Default `_`
* **fractionsep**. Default `/`
* **fractionwidth**. Integer. Try to pad zeros to the numerator until the fractional part has this width
* **tryden**. Integer. Try to use this denominator instead of a smaller one. No-op if it'd lose precision.
* **suffix**. String. This strings will be appended to the output. Useful for units/%
* **autoscale**. Symbol, default `:none`. It could be `:metric`, `:binary`, or `:finance`.
    * `:metric` implements common SI symbols for large and small numbers e.g. `M`, `k`, `μ`, `n`
    * `:binary` implements common ISQ symbols for large numbers e.g. `Ti`, `Gi`, `Mi`, `Ki`
    * `:finance` implements common finance/news symbols for large numbers e.g. `b` (billion), `m` (millions)

See the test script for more examples.

# core formatting functions

### auxiliary functions

### print char n times

function _repprint(out::IO, c::AbstractChar, n::Int)
    wid = textwidth(c)
    n < wid && return
    while n > 0
        print(out, c)
        n -= wid
    end
end

### print string or char

function _truncstr(s::AbstractString, slen, prec)
    prec == 0 && return ("", 0)
    i, n = 0, 1
    siz = ncodeunits(s)
    while n <= siz
	(prec -= textwidth(s[n])) < 0 && break
	i = n
        n = nextind(s, i)
    end
    str = SubString(s, 1, i)
    return (str, textwidth(str))
end

_truncstr(s::AbstractChar, slen, prec) = ("", 0)

function _pfmt_s(out::IO, fs::FormatSpec, s::Union{AbstractString,AbstractChar})
    slen = textwidth(s)
    str, slen = 0 <= fs.prec < slen ? _truncstr(s, slen, fs.prec) : (s, slen)
    prepad = postpad = 0
    pad = fs.width - slen
    if pad > 0
        if fs.align == '<'
            postpad = pad
        elseif fs.align == '^'
            prepad, postpad = pad>>1, (pad+1)>>1
        else
            prepad = pad
        end
    end
    # left padding
    prepad == 0 || _repprint(out, fs.fill, prepad)
    # print string
    print(out, str)
    # right padding
    postpad == 0 || _repprint(out, fs.fill, postpad)
end

_unsigned_abs(x::Signed) = unsigned(abs(x))
_unsigned_abs(x::Bool) = UInt(x)
_unsigned_abs(x::Unsigned) = x
# Special case because unsigned fails for BigInt
_unsigned_abs(x::BigInt) = abs(x)

_ndigits(x, ::_Dec) = ndigits(x)
_ndigits(x, ::_Bin) = ndigits(x, base=2)
_ndigits(x, ::_Oct) = ndigits(x, base=8)
_ndigits(x, ::Union{_Hex, _HEX}) = ndigits(x, base=16)

_sepcnt(::_Dec) = 3
_sepcnt(::Any) = 4

_mul(x::Integer, ::_Dec) = x * 10
_mul(x::Integer, ::_Bin) = x << 1
_mul(x::Integer, ::_Oct) = x << 3
_mul(x::Integer, ::Union{_Hex, _HEX}) = x << 4

_div(x::Integer, ::_Dec) = div(x, 10)
_div(x::Integer, ::_Bin) = x >> 1
_div(x::Integer, ::_Oct) = x >> 3
_div(x::Integer, ::Union{_Hex, _HEX}) = x >> 4

_ipre(op) = ""
_ipre(::_Oct) = "0o"
_ipre(::_Bin) = "0b"
_ipre(::_Hex) = "0x"
_ipre(::_HEX) = "0X"

_digitchar(x::Integer, ::_Bin) = x == 0 ? '0' : '1'
_digitchar(x::Integer, ::_Dec) = Char(Int('0') + x)
_digitchar(x::Integer, ::_Oct) = Char(Int('0') + x)
_digitchar(x::Integer, ::_Hex) = Char(x < 10 ? '0' + x : 'a' + (x - 10))
_digitchar(x::Integer, ::_HEX) = Char(x < 10 ? '0' + x : 'A' + (x - 10))

_signchar(x::Real, s::AbstractChar) = signbit(x) ? '-' : s == '+' ? '+' : s == ' ' ? ' ' : '\0'

### output integers (with or without separators)

function _outint(out::IO, ax::T, op::Op=_Dec()) where {Op, T<:Integer}
    b_lb = _div(ax, op)
    b = one(T)
    while b <= b_lb
        b = _mul(b, op)
    end
    r = ax
    while b > 0
        (q, r) = divrem(r, b)
        print(out, _digitchar(q, op))
        b = _div(b, op)
    end
end

function _outint(out::IO, ax::T, op::Op, numini, sep) where {Op, T<:Integer}
    b_lb = _div(ax, op)
    b = one(T)
    while b <= b_lb
        b = _mul(b, op)
    end
    r = ax
    while true
        (q, r) = divrem(r, b)
        print(out, _digitchar(q, op))
        b = _div(b, op)
        b == 0 && break
        if numini == 0
            numini = _sepcnt(op)
            print(out, sep)
        end
        numini -= 1
    end
end

# Print integer

function _pfmt_i(out::IO, fs::FormatSpec, x::Integer, op::Op) where {Op}
    # calculate actual length
    ax = _unsigned_abs(x)
    xlen = _ndigits(ax, op)
    numsep, numini = fs.tsep ? divrem(xlen-1, _sepcnt(op)) : (0, 0)
    xlen += numsep

    # sign char
    sch = _signchar(x, fs.sign)
    xlen += (sch != '\0')
    # prefix (e.g. 0x, 0b, 0o)
    ip = ""
    if fs.ipre
        ip = _ipre(op)
        xlen += length(ip)
    end
    # printing
    pad = fs.width - xlen
    prepad = postpad = zpad = 0
    if pad > 0
        if fs.zpad
            zpad = pad
        elseif fs.align == '<'
            postpad = pad
        elseif fs.align == '^'
            prepad, postpad = pad>>1, (pad+1)>>1
        else
            prepad = pad
        end
    end
    # left padding
    prepad == 0 || _repprint(out, fs.fill, prepad)
    # print sign
    sch != '\0' && print(out, sch)
    # print prefix
    !isempty(ip) && print(out, ip)
    # print padding zeros
    zpad > 0 && _repprint(out, '0', zpad)
    # print actual digits
    ax == 0 ? print(out, '0') :
        numsep == 0 ? _outint(out, ax, op) : _outint(out, ax, op, numini, fs.sep)
    # right padding
    postpad == 0 || _repprint(out, fs.fill, postpad)
end

function _truncval(v)
    try
        return trunc(Integer, v)
    catch e
        e isa InexactError || rethrow(e)
    end
    try
        return trunc(Int128, v)
    catch e
        e isa InexactError || rethrow(e)
    end
    trunc(BigInt, v)
end

### print floating point numbers

function _pfmt_f(out::IO, fs::FormatSpec, x::AbstractFloat)
    # Handle %
    percentflag = (fs.typ == '%')
    percentflag && (x *= 100)
    # separate sign, integer, and decimal part
    prec = fs.prec
    rax = round(abs(x); digits = prec)
    sch = _signchar(x, fs.sign)
    intv = _truncval(rax)
    decv = rax - intv

    # calculate length
    xlen = ndigits(intv)
    numsep, numini = fs.tsep ? divrem(xlen - 1, 3) : (0, 0)
    xlen += ifelse(prec > 0, prec + 1, 0) + (sch != '\0') + numsep + percentflag

    # calculate padding needed
    pad = fs.width - xlen
    prepad = postpad = zpad = 0
    if pad > 0
        if fs.zpad
            zpad = pad
        elseif fs.align == '<'
            postpad = pad
        elseif fs.align == '^'
            prepad, postpad = pad>>1, (pad+1)>>1
        else
            prepad = pad
        end
    end
    # left padding
    prepad == 0 || _repprint(out, fs.fill, prepad)

    # print sign
    sch != '\0' && print(out, sch)

    # print padding zeros
    zpad > 0 && _repprint(out, '0', zpad)

    # print integer part
    intv == 0 ? print(out, '0') :
        numsep == 0 ? _outint(out, intv) : _outint(out, intv, _Dec(), numini, fs.sep)

    # print decimal part
    if prec > 0
        print(out, '.')
        idecv = round(Integer, decv * exp10(prec))
        nd = ndigits(idecv)
        nd < prec && _repprint(out, '0', prec - nd)
        _outint(out, idecv)
    end

    # print trailing percent sign
    percentflag && print(out, '%')

    # right padding
    postpad == 0 || _repprint(out, fs.fill, postpad)
end

function _pfmt_e(out::IO, fs::FormatSpec, x::AbstractFloat)
    # extract sign, significand, and exponent
    prec = fs.prec
    ax = abs(x)
    sch = _signchar(x, fs.sign)
    if ax == 0.0
        e = 0
        u = zero(x)
    else
        rax = round(ax; sigdigits = prec + 1)
        e = floor(Integer, log10(rax))  # exponent
        u = round(rax * exp10(-e); sigdigits = prec + 1)  # significand
        i = 0
        v10 = 1
        while isinf(u)
            i += 1
            i > 18 && (u = 0.0; e = 0; break)
            v10 *= 10
            u = round(v10 * rax * exp10(-e - i); sigdigits = prec + 1)
        end
    end

    # calculate length
    xlen = 6 + prec + (sch != '\0') + (abs(e) > 99 ? ndigits(abs(e)) - 2 : 0)

    # calculate padding
    pad = fs.width - xlen
    prepad = postpad = zpad = 0
    if pad > 0
        if fs.zpad
            zpad = pad
        elseif fs.align == '<'
            postpad = pad
        elseif fs.align == '^'
            prepad, postpad = pad>>1, (pad+1)>>1
        else
            prepad = pad
        end
    end

    # left padding
    prepad == 0 || _repprint(out, fs.fill, prepad)

    # print sign
    sch != '\0' && print(out, sch)

    # print padding zeros
    zpad > 0 && _repprint(out, '0', zpad)

    # print actual digits
    intv = trunc(Integer, u)
    decv = u - intv
    if intv == 0 && decv != 0
        intv = 1
        decv -= 1
    end

    # print integer part (should always be 0-9)
    print(out, Char(Int('0') + intv))

    # print decimal part
    if prec > 0
        print(out, '.')
        idecv = round(Integer, decv * exp10(prec))
        nd = ndigits(idecv)
        nd < prec && _repprint(out, '0', prec - nd)
        _outint(out, idecv)
    end

    # print exponent
    print(out, isuppercase(fs.typ) ? 'E' : 'e')
    if e >= 0
        print(out, '+')
    else
        print(out, '-')
        e = -e
    end
    e < 10 && print(out, '0')
    _outint(out, e)
    # right padding
    postpad == 0 || _repprint(out, fs.fill, postpad)
end

function _pfmt_g(out::IO, fs::FormatSpec, x::AbstractFloat)
    # number decomposition
    ax = abs(x)
    if 1.0e-4 <= ax < 1.0e6
        _pfmt_f(out, fs, x)
    else
        _pfmt_e(out, fs, x)
    end
end

function _pfmt_specialf(out::IO, fs::FormatSpec, x::AbstractFloat)
    if isinf(x)
        _pfmt_s(out, fs, x > 0 ? "Inf" : "-Inf")
    else
        @assert isnan(x)
        _pfmt_s(out, fs, "NaN")
    end
end

# C-style formatting functions, originally based on Printf.jl

using Base.Ryu

abstract type FmtType end

struct FmtDec <: FmtType end
struct FmtOct <: FmtType end
struct FmtHex <: FmtType end
struct FmtChr <: FmtType end
struct FmtStr <: FmtType end
struct FmtPtr <: FmtType end

struct FmtFltE <: FmtType end
struct FmtFltF <: FmtType end
struct FmtFltG <: FmtType end
struct FmtFltA <: FmtType end

struct FmtN <: FmtType end

const VALID_FMTS = b"duoxefgacsipnDUOXEFGACS"

const FMT_TYPES = [FmtDec, FmtDec, FmtOct, FmtHex, FmtFltE, FmtFltF, FmtFltG, FmtFltA, FmtChr, FmtStr,
                   FmtDec, FmtPtr, FmtN]

# format specifier categories
const FmtInts = Union{FmtDec, FmtOct, FmtHex}
const FmtFlts = Union{FmtFltE, FmtFltF, FmtFltG, FmtFltA}

"""
Typed representation of a format specifier.

Fields are the various modifiers allowed for various format specifiers.
"""
struct FmtSpec{T<:FmtType}
    char::UInt8
    tsep::UInt8 # thousands separator (default ',')
    leftalign::Bool
    plus::Bool
    space::Bool
    zero::Bool
    altf::Bool # alternate formatting ('#' flag)
    width::Int # negative means *, 0 means no width specified
    prec::Int # -2 means *, -1 means no precision specified
end

# recreate the format specifier string from a typed FmtSpec
Base.string(f::FmtSpec; modifier::String="") =
    string("%",
           f.leftalign ? "-" : "",
           f.plus ? "+" : "",
           f.space ? " " : "",
           f.zero ? "0" : "",
           f.altf ? "#" : "",
           f.tsep == 0 ? "" : "'",
           f.width > 0 ? "$(f.width)" : f.width < 0 ? "*" : "",
           f.prec < -1 ? "*" : f.prec >= 0 ? ".$(f.prec)" : "",
           modifier,
           Char(f.char))
Base.show(io::IO, f::FmtSpec) = print(io, string(f))

floatfmt(s::FmtSpec) =
    FmtSpec{FmtFltF}(s.char, s.tsep, s.leftalign, s.plus, s.space, s.zero, s.altf, s.width, 0)
ptrfmt(s::FmtSpec, x) =
    FmtSpec{FmtHex}(s.char, s.tsep, s.leftalign, s.plus, s.space, s.zero, true, s.width,
                    ifelse(sizeof(x) == 8, 16, 8))

function FmtSpec(s::FmtSpec{F}; width=s.width, prec=s.prec) where {F}
    s.width < 0 || throw(ArgumentError("Already has width $(s.width)"))
    s.prec < -1 || throw(ArgumentError("Already has precision $(s.prec)"))
    width < 0 && throw(ArgumentError("Width $(width) must be >= 0"))
    prec < -1 && throw(ArgumentError("Precision $(prec) must be >= -1"))
    FmtSpec{F}(s.char, s.tsep, s.leftalign, s.plus, s.space, s.zero, s.altf, width, prec)
end

# parse format string
function FmtSpec(f::AbstractString)
    isempty(f) && throw(ArgumentError("empty format string"))
    bytes = codeunits(f) # Note: codeunits are not necessarily *bytes*!
    len = length(bytes)
    bytes[1] === UInt8('%') || throw(ArgumentError("Format string doesn't start with %"))
    b = bytes[2]
    pos = 3
    # positioned at start of first format str %
    # parse flags
    leftalign = plus = space = zero = altf = false
    tsep = UInt8(0)
    while true
        if b == UInt8('-')
            leftalign = true
        elseif b == UInt8('+')
            plus = true
        elseif b == UInt8(' ')
            space = true
        elseif b == UInt8('0')
            zero = true
        elseif b == UInt8('#')
            altf = true
        elseif b == UInt8('\'')
            tsep = UInt8(',')
        else
            break
        end
        pos > len && throw(ArgumentError("incomplete format string: '$f'"))
        b = bytes[pos]
        pos += 1
    end
    leftalign && (zero = false)
    # parse width
    if b == UInt('*')
        width = -1
    else
        width = 0
        while b - UInt8('0') < 0x0a
            width = 10 * width + (b - UInt8('0'))
            b = bytes[pos]
            pos += 1
            pos > len && break
        end
    end
    # parse prec
    prec = 0
    parsedprecdigits = false
    if b == UInt8('.')
        pos > len && throw(ArgumentError("incomplete format string: '$f'"))
        parsedprecdigits = true
        b = bytes[pos]
        pos += 1
        if pos <= len
            if b == UInt('*')
                prec == -2
            else
                prec = 0
                while b - UInt8('0') < 0x0a
                    prec = 10 * prec + (b - UInt8('0'))
                    b = bytes[pos]
                    pos += 1
                    pos > len && break
                end
            end
        end
    end
    # parse length modifier (ignored)
    if b == UInt8('h') || b == UInt8('l')
        prev = b
        pos > len &&
            throw(ArgumentError("format string - length modifier is missing type specifier: '$f'"))
        b = bytes[pos]
        pos += 1
        if b == prev
            pos > len && throw(ArgumentError("invalid format string: '$f'"))
            b = bytes[pos]
            pos += 1
        end
    elseif b in b"Ljqtz"
        pos > len &&
            throw(ArgumentError("format string - length modifier is missing type specifier: '$f'"))
        b = bytes[pos]
        pos += 1
    end
    # parse type
    fmtind = findfirst(isequal(b), VALID_FMTS)
    fmtind === nothing &&
        throw(ArgumentError(string("invalid format string: '$f', ",
                                   "invalid type specifier: '$(Char(b))'")))
    # Check for uppercase variants
    fmtind > 13 && (fmtind -= 13)
    fmttyp = FMT_TYPES[fmtind]
    if fmttyp <: FmtInts && prec > 0
        zero = false
    elseif !parsedprecdigits
        if (fmttyp === FmtStr || fmttyp === FmtChr || fmttyp === FmtFltA)
            prec = -1
        elseif fmttyp <: FmtFlts
            prec = 6
        end
    end
    FmtSpec{fmttyp}(b, tsep, leftalign, plus, space, zero, altf, width, prec)
end

@inline gethexbase(spec) = spec.char < UInt8('a') ? b"0123456789ABCDEF" : b"0123456789abcdef"

@inline upchar(spec, ch) = (spec.char & 0x20) | UInt8(ch)

# write out a single arg according to format options
# char
@inline function writechar(buf, pos, c::Char)
    u = bswap(reinterpret(UInt32, c))
    while true
        @inbounds buf[pos] = u % UInt8
        pos += 1
        (u >>= 8) == 0 && break
    end
    return pos
end

@inline function padn(buf, pos, cnt)
    @inbounds for _ = 1:cnt
        buf[pos] = UInt8(' ')
        pos += 1
    end
    pos
end

@inline function padzero(buf, pos, cnt)
    @inbounds for _ = 1:cnt
        buf[pos] = UInt8('0')
        pos += 1
    end
    pos
end

function _fmt(buf, pos, spec::FmtSpec{FmtChr}, arg)
    ch = arg isa String ? arg[1] : Char(arg)
    width = spec.width - textwidth(ch)
    width <= 0 && return writechar(buf, pos, ch)
    if spec.leftalign
        padn(buf, writechar(buf, pos, ch), width)
    else
        writechar(buf, padn(buf, pos, width), ch)
    end
end

@inline function outch(buf, pos, ch)
    @inbounds buf[pos] = UInt8(ch)
    pos + 1
end
@inline function outch(buf, pos, c1, c2)
    @inbounds buf[pos] = UInt8(c1)
    @inbounds buf[pos + 1] = UInt8(c2)
    pos + 2
end
@inline function outch(buf, pos, c1, c2, c3)
    @inbounds buf[pos] = UInt8(c1)
    @inbounds buf[pos + 1] = UInt8(c2)
    @inbounds buf[pos + 2] = UInt8(c3)
    pos + 3
end

# strings
function _fmt(buf, pos, spec::FmtSpec{FmtStr}, arg)
    altf, width, prec = spec.altf, spec.width, spec.prec
    s = altf && (arg isa Symbol || arg isa AbstractString) ? repr(arg) : string(arg)
    slen = textwidth(s)
    str, slen = 0 <= prec < slen ? _truncstr(s, slen, prec) : (s, slen)
    prepad = postpad = 0
    pad = width - slen
    if pad > 0
        if spec.leftalign
            postpad = pad
        else
            prepad = pad
        end
    end

    # Make sure there is enough room in buffer
    nlen = pos + prepad + sizeof(str) + postpad
    nlen > sizeof(buf) && resize!(buf, nlen)

    prepad == 0 || (pos = padn(buf, pos, prepad))
    for c in str
        pos = writechar(buf, pos, c)
    end
    return postpad == 0 ? pos : padn(buf, pos, postpad)
end

const BaseInt = Union{Int8, Int16, Int32, Int64, Int128}
const BaseUns = Union{UInt8, UInt16, UInt32, UInt64, UInt128}

base(::Type{FmtOct}) = 8
base(::Type{FmtDec}) = 10
base(::Type{FmtHex}) = 16

# integers

_fmt(buf, pos, spec::FmtSpec{<:FmtInts}, arg::AbstractFloat) =
    _fmt(buf, pos, floatfmt(spec), arg)

_fmt(buf, pos, spec::FmtSpec{T}, arg::Real) where {T<:FmtInts} =
    _fmt(buf, pos, spec, arg < 0, string(abs(arg); base=base(T)))
_fmt(buf, pos, spec::FmtSpec{<:FmtInts}, arg::BaseUns) =
    _fmt(buf, pos, spec, false, arg)
_fmt(buf, pos, spec::FmtSpec{<:FmtInts}, arg::BaseInt) =
    _fmt(buf, pos, spec, arg < 0, unsigned(abs(arg)))

hex_len(x) = x == 0 ? 1 : (sizeof(x)<<1) - (leading_zeros(x)>>2)
oct_len(x) = x == 0 ? 1 : div((sizeof(x)<<3) - leading_zeros(x)+2, 3)

function _fmt(buf, pos, spec::FmtSpec{F}, neg, x::T) where {F<:FmtInts,T<:Union{String,BaseUns}}
    n = T === String ? sizeof(x) :
        F === FmtDec ? dec_len(x) : F === FmtHex ? hex_len(x) : oct_len(x)
    i = n
    arglen = n + (neg || (spec.plus | spec.space)) +
        ((spec.altf && (F !== FmtDec)) ? ifelse(F === FmtOct, 1, 2) : 0)
    width, prec = spec.width, spec.prec
    precpad = max(0, prec - n)
    # Calculate width including padding due to width or precision
    arglen2 = arglen < width && prec > 0 ? arglen + min(precpad, width - arglen) : arglen

    # Make sure that remaining output buffer is large enough
    # This means that it isn't necessary to preallocate for cases that usually will never happen
    buflen = pos + max(width, arglen + precpad)
    buflen > sizeof(buf) && resize!(buf, buflen)

    !spec.leftalign && !spec.zero && arglen2 < width &&
        (pos = padn(buf, pos, width - arglen2))
    if neg
        pos = outch(buf, pos, '-')
    elseif spec.plus # plus overrides space
        pos = outch(buf, pos, '+')
    elseif spec.space
        pos = outch(buf, pos, ' ')
    end
    if spec.altf
        if F === FmtOct
            pos = outch(buf, pos, '0')
        elseif F === FmtHex
            pos = outch(buf, pos, '0', upchar(spec, 'X'))
        end
    end
    if spec.zero && arglen2 < width
        pos = padzero(buf, pos, width - arglen2)
    elseif n < prec
        pos = padzero(buf, pos, precpad)
    elseif arglen < arglen2
        pos = padzero(buf, pos, arglen2 - arglen)
    end
    if T === String
        GC.@preserve buf x begin
            unsafe_copyto!(pointer(buf, pos), pointer(x), n)
        end
    elseif F === FmtDec
        while i > 0
            d, r = divrem(x, 10)
            @inbounds buf[pos + i - 1] = UInt8('0') + r
            x = oftype(x, d)
            i -= 1
        end
    elseif F === FmtHex
        hexbase = gethexbase(spec)
        while i > 0
            @inbounds buf[pos + i - 1] = hexbase[(x & 0x0f) + 1]
            x >>= 4
            i -= 1
        end
    else # F === FmtOct
        while i > 0
            @inbounds buf[pos + i - 1] = UInt8('0') + (x & 0x07)
            x >>= 3
            i -= 1
        end
    end
    (spec.leftalign && arglen2 < width) ? padn(buf, pos + n, width - arglen2) : (pos + n)
end

# floats
"""
    tofloat(x)

Convert an argument to a Base float type for printf formatting.
By default, arguments are converted to `Float64` via `Float64(x)`.
Custom numeric types that have a conversion to a Base float type
that wish to hook into printf formatting can extend this method like:

```julia
Printf.tofloat(x::MyCustomType) = convert_my_custom_type_to_float(x)
```

For arbitrary precision numerics, you might extend the method like:

```julia
Printf.tofloat(x::MyArbitraryPrecisionType) = BigFloat(x)
```
"""
tofloat(x) = Float64(x)
tofloat(x::Base.IEEEFloat) = x

function output_fmt_a(buf, pos, spec, neg, x)
    if neg
        pos = outch(buf, pos, '-')
    elseif spec.plus
        pos = outch(buf, pos, '+')
    elseif spec.space
        pos = outch(buf, pos, ' ')
    end
    isnan(x) && return outch(buf, pos, 'N', 'a', 'N')
    isfinite(x) || return outch(buf, pos, 'I', 'n', 'f')
    prec = spec.prec
    pos = outch(buf, pos, '0', upchar(spec, 'X'))
    if x == 0
        pos = outch(buf, pos, '0')
        prec > 0 && (pos = outch(buf, pos, '.'); pos = padzero(buf, pos, prec))
        return outch(buf, pos, upchar(spec, 'P'), '+', '0')
    end
    s, p = frexp(x)
    prec = spec.prec
    if prec > -1
        sigbits = 4 * min(prec, 13)
        s = 0.25 * round(ldexp(s, 1 + sigbits))
        # ensure last 2 exponent bits either 01 or 10
        u = (reinterpret(UInt64, s) & 0x003f_ffff_ffff_ffff) >> (52 - sigbits)
        i = n = (sizeof(u) << 1) - (leading_zeros(u) >> 2)
    else
        s *= 2.0
        u = (reinterpret(UInt64, s) & 0x001f_ffff_ffff_ffff)
        t = (trailing_zeros(u) >> 2)
        u >>= (t << 2)
        i = n = 14 - t
    end
    frac = u > 9 || spec.altf || prec > 0
    hexbase = gethexbase(spec)
    while i > 1
        buf[pos + i] = hexbase[(u & 0x0f) + 1]
        u >>= 4
        i -= 1
        prec -= 1
    end
    frac && (buf[pos + 1] = UInt8('.'))
    buf[pos] = hexbase[(u & 0x0f) + 1]
    pos += n + frac
    while prec > 0
        pos = outch(buf, pos, '0')
        prec -= 1
    end
    pos = outch(buf, pos, upchar(spec, 'P'))
    p -= 1
    pos = outch(buf, pos, p < 0 ? UInt8('-') : UInt8('+'))
    p = p < 0 ? -p : p
    n = i = ndigits(p, base=10, pad=1)
    while i > 0
        d, r = divrem(p, 10)
        buf[pos + i - 1] = UInt8('0') + r
        p = oftype(p, d)
        i -= 1
    end
    return pos + n
end

const _strspec = Dict{FmtSpec,ASCIIStr}()

"""Get the format specification, prepared for use with MPFR for BigFloats"""
function _get_strspec(spec)
    global _strspec
    chkspec = get(_strspec, spec, nothing)
    chkspec === nothing || return chkspec
    _strspec[spec] = string(spec; modifier="R")
end

@static if VERSION < v"1.5"
_snprintf(ptr, siz, spec, arg) =
    ccall((:mpfr_snprintf,:libmpfr), Int32,
          (Ptr{UInt8}, Culong, Ptr{UInt8}, Ref{BigFloat}...),
          ptr, siz, spec, arg)
else
_snprintf(ptr, siz, spec, arg) =
    @ccall "libmpfr".mpfr_snprintf(ptr::Ptr{UInt8}, siz::Csize_t, spec::Ptr{UInt8};
                                   arg::Ref{BigFloat})::Cint
end

function _fmt(buf, pos, spec::FmtSpec{<:FmtFlts}, arg::BigFloat)
    isfinite(arg) || return _fmt(buf, pos, spec, Float64(arg))
    strspec = _get_strspec(spec)
    siz = length(buf) - pos + 1
    # Calculate size needed for most common outputs
    len = max(spec.width, ceil(Int, precision(arg) * log(2)/log(10)) + 24)
    if len > siz
        resize!(buf, pos + len + 1)
        siz = length(buf) - pos + 1
    end
    GC.@preserve buf begin
        len = _snprintf(pointer(buf, pos), siz, strspec, arg)
        if len > siz
            resize!(buf, pos + len + 1)
            len = _snprintf(pointer(buf, pos), len + 1, strspec, arg)
        end
    end
    len > 0 || error("invalid printf formatting for BigFloat")
    pos + len
end

function _fmt(buf, pos, spec::FmtSpec{T}, arg) where {T <: FmtFlts}
    # Make sure there is enough room
    width, prec, plus, space, hash = spec.width, spec.prec, spec.plus, spec.space, spec.altf
    buflen = sizeof(buf) - pos
    needed = max(width, 309 + 17 + 5)
    buflen < needed && resize!(buf, pos + needed)

    x = tofloat(arg)
    if T === FmtFltE
        newpos = Ryu.writeexp(buf, pos, x, prec, plus, space, hash, upchar(spec, 'E'), UInt8('.'))
    elseif T === FmtFltF
        newpos = Ryu.writefixed(buf, pos, x, prec, plus, space, hash, UInt8('.'))
    elseif T === FmtFltG
        if isinf(x) || isnan(x)
            newpos = Ryu.writeshortest(buf, pos, x, plus, space)
        else
            # C11-compliant general format
            prec = prec == 0 ? 1 : prec
            # format the value in scientific notation and parse the exponent part
            exp = let p = Ryu.writeexp(buf, pos, x, prec)
                b1, b2, b3, b4 = buf[p-4], buf[p-3], buf[p-2], buf[p-1]
                Z = UInt8('0')
                if b1 == UInt8('e')
                    # two-digit exponent
                    sign = b2 == UInt8('+') ? 1 : -1
                    exp = 10 * (b3 - Z) + (b4 - Z)
                else
                    # three-digit exponent
                    sign = b1 == UInt8('+') ? 1 : -1
                    exp = 100 * (b2 - Z) + 10 * (b3 - Z) + (b4 - Z)
                end
                flipsign(exp, sign)
            end
            if -4 ≤ exp < prec
                newpos = Ryu.writefixed(buf, pos, x, prec - (exp + 1), plus, space, hash,
                                        UInt8('.'), !hash)
            else
                newpos = Ryu.writeexp(buf, pos, x, prec - 1, plus, space, hash,
                                      upchar(spec, 'E'), UInt8('.'), !hash)
            end
        end
    elseif T === FmtFltA
        x, neg = x < 0 || x === -Base.zero(x) ? (-x, true) : (x, false)
        newpos = output_fmt_a(buf, pos, spec, neg, x)
    end
    if newpos - pos < width
        # need to pad
        if spec.leftalign
            # easy case, just pad spaces after number
            newpos = padn(buf, newpos, width - (newpos - pos))
        else
            # right aligned
            n = width - (newpos - pos)
            if spec.zero && isfinite(x)
                ex = (arg < 0 || (plus | space)) + ifelse(T === FmtFltA, 2, 0)
                so = pos + ex
                len = (newpos - pos) - ex
                copyto!(buf, so + n, buf, so, len)
                for i = so:(so + n - 1)
                    buf[i] = UInt8('0')
                end
                newpos += n
            else
                copyto!(buf, pos + n, buf, pos, newpos - pos)
                for i = pos:(pos + n - 1)
                    buf[i] = UInt8(' ')
                end
                newpos += n
            end
        end
    end
    return newpos
end

# pointers
_fmt(buf, pos, spec::FmtSpec{FmtPtr}, arg) =
    _fmt(buf, pos, ptrfmt(spec, arg), UInt64(arg))

@inline _dec_len1(v) = ifelse(v < 100, ifelse(v < 10, 1, 2), 3)
@inline _dec_len2(v) = v < 1_000 ? _dec_len1(v) : ifelse(v < 10_000, 4, 5)
@inline _dec_len4(v) = v < 100_000 ? _dec_len2(v) :
    (v < 10_000_000
     ? ifelse(v < 1_000_000, 6, 7)
     : ifelse(v < 100_000_000, 8, ifelse(v < 1_000_000_000, 9, 10)))
@inline function _dec_len8(v)
    if v < 1_000_000_000 # 1 - 9 digits
        _dec_len4(v)
    elseif v < 10_000_000_000_000 # 10 - 13 digits
        if v < 100_000_000_000
            ifelse(v < 10_000_000_000, 10, 11)
        else
            ifelse(v < 1_000_000_000_000, 12, 13)
        end
    elseif v < 100_000_000_000_000_000 # 14 - 17 digits
        if v < 1_000_000_000_000_000
            ifelse(v < 100_000_000_000_000, 14, 15)
        else
            ifelse(v < 10_000_000_000_000_000, 16, 17)
        end
    else
        v < 10_000_000_000_000_000_000 ? ifelse(v < 1_000_000_000_000_000_000, 18, 19) : 20
    end
end

@inline dec_len(v::UInt8)  = _dec_len1(v)
@inline dec_len(v::UInt16) = _dec_len2(v)
@inline dec_len(v::UInt32) = _dec_len4(v)
@inline dec_len(v::UInt64) = _dec_len8(v)
@inline function dec_len(v::UInt128)
    v <= typemax(UInt64) && return _dec_len8(v%UInt64)
    v = div(v, 0x8ac7230489e80000) # 10^19
    v <= typemax(UInt64) ? _dec_len8(v%UInt64) + 19 : 39
end

_erfinv(z) = sqrt(π) * Base.Math.@horner(z, 0, 1, 0, π/12, 0, 7π^2/480, 0, 127π^3/40320, 0,
                                         4369π^4/5806080, 0, 34807π^5/182476800) / 2

set_seed!(seed) = Random.seed!(seed)

function test_equality()
    println( "test cformat equality...")
    set_seed!(10)
    fmts = [ (x->@sprintf("%10.4f",x), "%10.4f"),
             (x->@sprintf("%f", x),    "%f"),
             (x->@sprintf("%e", x),    "%e"),
             (x->@sprintf("%10f", x),  "%10f"),
             (x->@sprintf("%.3f", x),  "%.3f"),
             (x->@sprintf("%.3e", x),  "%.3e")]
    for (mfmtr,fmt) in fmts
        for i in 1:10000
            n = _erfinv( rand() * 1.99 - 1.99/2.0 )
            expect = mfmtr( n )
            actual = cfmt( fmt, n )
            @test expect == actual
        end
    end

    fmts = [ (x->@sprintf("%d",x),    "%d"),
             (x->@sprintf("%10d",x),  "%10d"),
             (x->@sprintf("%010d",x), "%010d"),
             (x->@sprintf("%-10d",x), "%-10d")]
    for (mfmtr,fmt) in fmts
        for i in 1:10000
            j = round(Int, _erfinv( rand() * 1.99 - 1.99/2.0 ) * 100000 )
            expect = mfmtr( j )
            actual = cfmt( fmt, j )
            @test expect == actual
        end
    end
    println( "...Done" )
end

@time test_equality()

include("speedtest.jl")

@testset "test commas..." begin
    @test cfmt( "%'d", 1000 ) == "1,000"
    @test cfmt( "%'d", -1000 ) == "-1,000"
    @test cfmt( "%'d", 100 ) == "100"
    @test cfmt( "%'d", -100 ) == "-100"
    @test cfmt( "%'f", Inf ) == "Inf"
    @test cfmt( "%'f", -Inf ) == "-Inf"
    @test cfmt( "%'s", 1000.0 ) == "1,000.0"
    @test cfmt( "%'s", 1234567.0 ) == "1.234567e6"
    @test cfmt( "%'g", 1000.0 ) == "1,000"
end

@testset "Test bug introduced by stdlib/Printf rewrite" begin
    @test cfmt( "%4.2s", "a" ) == "   a"
end

@testset "Test precision with wide characters" begin
    @test cfmt( "%10.9s", "\U1f355" ^ 6) == "  " * "\U1f355" ^ 4
    @test cfmt( "%10.10s", "\U1f355" ^ 6) == "\U1f355" ^ 5
end

@testset "test format..." begin
    @test format( 10 ) == "10"
    @test format( 10.0 ) == "10"
    @test format( 10.0, precision=2 ) == "10.00"
    @test format( 111//100, precision=2 ) == "1.11"
    @test format( 111//100 ) == "111/100"
    @test format( 1234, commas=true ) == "1,234"
    @test format( 1234, conversion="f", precision=2 ) == "1234.00"
    @test format( 1.23, precision=3 ) == "1.230"
    @test format( 1.23, precision=3, stripzeros=true ) == "1.23"
    @test format( 1.00, precision=3, stripzeros=true ) == "1"

    @test format( 1.0, conversion="e", stripzeros=true ) == "1e+00"
    @test format( 1.0, conversion="e", precision=4 ) == "1.0000e+00"
    @test format( 1.0, signed=true ) == "+1"
    @test format( 1.0, positivespace=true ) == " 1"
    @test_throws ErrorException format( 1234.56, signed=true, commas=true )
    @test format( 1.0, width=6, precision=4, stripzeros=true, leftjustified=true) == "1     "
end

@testset "hex output" begin
    @test format( 1118, conversion="x" ) == "45e"
    @test format( 1118, width=4, conversion="x" ) == " 45e"
    @test format( 1118, width=4, zeropadding=true, conversion="x" ) == "045e"
    @test format( 1118, alternative=true, conversion="x" ) == "0x45e"
    @test format( 1118, width=4, alternative=true, conversion="x" ) == "0x45e"
    @test format( 1118, width=6, alternative=true, conversion="x", zeropadding=true ) == "0x045e"
end

@testset "mixed fractions" begin
    @test format( 3//2, mixedfraction=true ) == "1_1/2"
    @test format( -3//2, mixedfraction=true ) == "-1_1/2"
    @test format( 3//100, mixedfraction=true ) == "3/100"
    @test format( -3//100, mixedfraction=true ) == "-3/100"
    @test format( 307//100, mixedfraction=true ) == "3_7/100"
    @test format( -307//100, mixedfraction=true ) == "-3_7/100"
    @test format( 307//100, mixedfraction=true, fractionwidth=6 ) == "3_07/100"
    @test format( -307//100, mixedfraction=true, fractionwidth=6 ) == "-3_07/100"
    @test format( -302//100, mixedfraction=true ) == "-3_1/50"
    # try to make the denominator 100
    @test format( -302//100, mixedfraction=true,tryden = 100 ) == "-3_2/100"
    @test format( -302//30, mixedfraction=true,tryden = 100 ) == "-10_1/15" # lose precision otherwise
    @test format( -302//100, mixedfraction=true,tryden = 100,fractionwidth=6 ) == "-3_02/100" # lose precision otherwise
end

@testset "commas" begin
    @test format( 12345678, width=10, commas=true ) == "12,345,678"
    # it would try to squeeze out the commas
    @test format( 12345678, width=9, commas=true ) == "12345,678"
    # until it can't anymore
    @test format( 12345678, width=8, commas=true ) == "12345678"
    @test format( 12345678, width=7, commas=true ) == "12345678"

    # only the numerator would have commas
    @test format( 1111//1000, commas=true ) == "1,111/1000"

    # this shows how, with enough space, parens line up with empty spaces
    @test format(  12345678, width=12, commas=true, parens=true )== " 12,345,678 "
    @test format( -12345678, width=12, commas=true, parens=true )== "(12,345,678)"
    # same with unspecified width
    @test format(  12345678, commas=true, parens=true )== " 12,345,678 "
    @test format( -12345678, commas=true, parens=true )== "(12,345,678)"
end

@testset "autoscale" begin
    @test format( 1.2e9, autoscale = :metric ) == "1.2G"
    @test format( 1.2e6, autoscale = :metric ) == "1.2M"
    @test format( 1.2e3, autoscale = :metric ) == "1.2k"
    @test format( 1.2e-6, autoscale = :metric ) == "1.2μ"
    @test format( 1.2e-9, autoscale = :metric ) == "1.2n"
    @test format( 1.2e-12, autoscale = :metric ) == "1.2p"

    @test format( 1.2e9, autoscale = :finance ) == "1.2b"
    @test format( 1.2e6, autoscale = :finance ) == "1.2m"
    @test format( 1.2e3, autoscale = :finance ) == "1.2k"

    @test format( 0x40000000, autoscale = :binary ) == "1Gi"
    @test format( 0x100000, autoscale = :binary ) == "1Mi"
    @test format( 0x800, autoscale = :binary ) == "2Ki"
    @test format( 0x400, autoscale = :binary ) == "1Ki"
end

@testset "suffix" begin
    @test format( 100.00, precision=2, suffix="%" ) == "100.00%"
    @test format( 100, precision=2, suffix="%" ) == "100%"
    @test format( 100, precision=2, suffix="%", conversion="f" ) == "100.00%"
end

# interface proposal by Tom Breloff (@tbreloff)... comments welcome
# This uses the more basic formatting based on FormatSpec and the pyfmt method
# (formerly called fmt, which I repurposed)

# TODO: swap out FormatSpec for something that is able to use the "format" method,
# which has more options for units, prefixes, etc
# TODO: support rational numbers, autoscale, etc as in "format"

# --------------------------------------------------------------------------------------------------

# the DefaultSpec object is just something to hold onto the current FormatSpec.
# we keep the typechar around specifically for the reset! function,
# to go back to the starting state

mutable struct DefaultSpec
    typechar::Char
    kwargs::Any
    fspec::FormatSpec
end

DefaultSpec(c::AbstractChar) = DefaultSpec(Char(c), (), FormatSpec(c))
function DefaultSpec(c::AbstractChar, syms...; kwargs...)
    # otherwise update the spec
    if isempty(syms)
        DefaultSpec(Char(c), kwargs, FormatSpec(c; kwargs...))
    else
        kw = _add_kwargs_from_symbols(kwargs, syms...)
        DefaultSpec(Char(c), tuple(kw...), FormatSpec(c; kw...))
    end
end

const DEFAULT_FORMATTERS = Dict{DataType, DefaultSpec}()

# adds a new default formatter for this type
default_spec!(::Type{T}, c::AbstractChar) where {T} =
    (DEFAULT_FORMATTERS[T] = DefaultSpec(c); nothing)

# note: types T and K will now both share K's default
default_spec!(::Type{T}, ::Type{K}) where {T,K} =
    (DEFAULT_FORMATTERS[T] = DEFAULT_FORMATTERS[K]; nothing)

default_spec!(::Type{T}, c::AbstractChar, syms...; kwargs...) where {T} =
    (DEFAULT_FORMATTERS[T] = DefaultSpec(c, syms...; kwargs...); nothing)

function reset!(::Type{T}) where {T}
    dspec = default_spec(T)
    dspec.fspec = FormatSpec(dspec.typechar; dspec.kwargs...)
    nothing
end

# --------------------------------------------------------------------------------------------------

function _add_kwargs_from_symbols(kwargs, syms::Symbol...)
    d = Dict{Symbol, Any}(kwargs)
    for s in syms
        if s == :ljust || s == :left
            d[:align] = '<'
        elseif s == :rjust || s == :right
            d[:align] = '>'
        elseif s == :center
            d[:align] = '^'
        elseif s == :commas
            d[:tsep] = true
        elseif s == :zpad || s == :zeropad
            d[:zpad] = true
        elseif s == :ipre || s == :prefix
            d[:ipre] = true
        end
    end
    d
end

# --------------------------------------------------------------------------------------------------

# methods to get the current default objects
# note: if you want to set a default for an abstract type (i.e. AbstractFloat)
# you'll need to extend this method like here:
default_spec(::Type{<:Integer})        = DEFAULT_FORMATTERS[Integer]
default_spec(::Type{<:AbstractFloat})  = DEFAULT_FORMATTERS[AbstractFloat]
default_spec(::Type{<:AbstractString}) = DEFAULT_FORMATTERS[AbstractString]
default_spec(::Type{<:AbstractChar})   = DEFAULT_FORMATTERS[AbstractChar]
default_spec(::Type{<:AbstractIrrational}) = DEFAULT_FORMATTERS[AbstractIrrational]
default_spec(::Type{<:Number})         = DEFAULT_FORMATTERS[Number]

default_spec(::Type{T}) where {T} =
    get(DEFAULT_FORMATTERS, T) do
        error("Missing default spec for type $T... call default!(T, c): $DEFAULT_FORMATTERS")
    end

default_spec(x) = default_spec(typeof(x))

fmt_default(::Type{T}) where {T} = default_spec(T).fspec
fmt_default(x) = default_spec(x).fspec


# first resets the fmt_default spec to the given arg,
# then continue by updating with args and kwargs
fmt_default!(::Type{T}, c::AbstractChar, args...; kwargs...) where {T} =
    (default_spec!(T,c); fmt_default!(T, args...; kwargs...))
fmt_default!(::Type{T}, ::Type{K}, args...; kwargs...) where {T,K} =
    (default_spec!(T,K); fmt_default!(T, args...; kwargs...))

# update the fmt_default for a specific type
function fmt_default!(::Type{T}, syms::Symbol...; kwargs...) where {T}
    if isempty(syms)

        # if there are no arguments, reset to initial defaults
        if isempty(kwargs)
            reset!(T)
            return
        end

        # otherwise update the spec
        dspec = default_spec(T)
        dspec.fspec = FormatSpec(dspec.fspec; kwargs...)

    else
        d = _add_kwargs_from_symbols(kwargs, syms...)
        fmt_default!(T; d...)
    end
    nothing
end

# update the fmt_default for all types
function fmt_default!(syms::Symbol...; kwargs...)
    if isempty(syms)
        for k in keys(DEFAULT_FORMATTERS)
            fmt_default!(k; kwargs...)
        end
    else
        d = _add_kwargs_from_symbols(kwargs, syms...)
        fmt_default!(; d...)
    end
    nothing
end

# --------------------------------------------------------------------------------------------------

# TODO: get rid of this entire hack by moving commas into pyfmt

function _optional_commas(x::Real, s::AbstractString, fspec::FormatSpec)
    prevwidth = length(s)
    dpos = findfirst( isequal('.'), s)
    ns = addcommas(s, prevwidth, dpos === nothing ? prevwidth : dpos - 1, fspec.sep)
    # check for excess width from commas
    w = length(s)
    (fspec.width > 0 && w > fspec.width && w > prevwidth) ? s : ns
end
_optional_commas(x, s::AbstractString, fspec::FormatSpec) = s

# --------------------------------------------------------------------------------------------------

"""
Creates a new FormatSpec by overriding the defaults and passes it to pyfmt

Optionally width and precision can be passed positionally, after the value to be formatted.

Some keyword arguments can be passed simply as symbols:
```
Symbol            | Meaning
------------------|------------------------------------------
:ljust or :left   | Left justified, same as < for FormatSpec
:rjust or :right  | Right justified, same as > for FormatSpec
:center           | Center justified, same as ^ for FormatSpec
:zpad or :zeropad | Pad with 0s on left
:ipre or :prefix  | Whether to prefix 0b, 0o, or 0x
:commas           | Add commas every 3 digits
```

Also, keyword arguments can be given:
```
Keyword | Type | Meaning                   | Default
--------|------|---------------------------|-------
fill    | Char | Fill character            | ' '
align   | Char | Alignment character       | '\\0'
sign    | Char | Sign character            | '-'
width   | Int  | Field width               | -1, i.e. ignored
prec    | Int  | Floating Precision        | -1, i.e. ignored
ipre    | Bool | Use 0b, 0o, or 0x prefix? | false
zpad    | Bool | Pad with 0s on left       | false
tsep    | Bool | Use thousands separator?  | false
```
"""
function fmt end

# TODO: do more caching to optimize repeated calls

# creates a new FormatSpec by overriding the defaults and passes it to pyfmt
# note: adding kwargs is only appropriate for one-off formatting.  
#       normally it will be much faster to change the fmt_default formatting as needed
function fmt(x; kwargs...)
    fspec = fmt_default(x)
    isempty(kwargs) || (fspec = FormatSpec(fspec; kwargs...))
    pyfmt(fspec, x)
end

# some helper method calls, which just convert to kwargs
fmt(x, width::Int, args...; kwargs...) = fmt(x, args...; width=width, kwargs...)

fmt(x, width::Int, prec::Int, args...; kwargs...) =
    fmt(x, args...; width=width, prec=prec, kwargs...)

# integrate some symbol shorthands into the keyword args
# note: as above, this will generate relevant kwargs, so to format in a tight loop,
# you should probably update the fmt_default

function fmt(x, syms::Symbol...; kwargs...)
    d = _add_kwargs_from_symbols(kwargs, syms...)
    fmt(x; d...)
end

# --------------------------------------------------------------------------------------------------

# seed it with some basic default formatters
for (t, c) in [(Integer,'d'),
               (AbstractFloat,'f'),
               (AbstractChar,'c'),
               (AbstractString,'s')]
    default_spec!(t, c)
end

default_spec!(Number, 's', :right)
default_spec!(AbstractIrrational, 's', :right)

include("printf.jl")

const _formatters = Dict{ASCIIStr,FmtSpec}()

function _get_formatter(fmt)
    global _formatters

    chkfmt = get(_formatters, fmt, nothing)
    chkfmt === nothing || return chkfmt
    _formatters[fmt] = FmtSpec(fmt)
end

_cfmt_comma(fspec::FmtSpec, x) = addcommasreal(_cfmt(fspec, x), Char(fspec.tsep))
_cfmt_comma(fspec::FmtSpec{FmtStr}, x::Rational) =  addcommasrat(_cfmt(fspec, x), Char(fspec.tsep))
_cfmt_comma(fspec::FmtSpec{<:FmtInts}, x) = checkcommas(_cfmt(fspec, x), Char(fspec.tsep))

function _cfmt(fspec::FmtSpec, x)
    sv = Base.StringVector(23) # Trust that lower level code will expand if necessary
    pos = _fmt(sv, 1, fspec, x)
    resize!(sv, pos - 1)
    String(sv)
end

cfmt(fspec::FmtSpec, x) = fspec.tsep == 0 ? _cfmt(fspec, x) : _cfmt_comma(fspec, x)
cfmt(fmtstr::ASCIIStr, x) = cfmt(_get_formatter(fmtstr), x)

function generate_formatter(fmt::ASCIIStr)
    fspec = _get_formatter(fmt)
    fspec.tsep == 0 ? x -> _cfmt(fspec, x) : x -> _cfmt_comma(fspec, x)
end

function addcommasreal(s, sep)
    len = length(s)
    dpos = findfirst( isequal('.'), s )
    dpos !== nothing && return addcommas(s, len, dpos-1, sep)
    # find the rightmost digit
    for i in len:-1:1
        isdigit( s[i] ) && return addcommas(s, len, i, sep)
    end
    s
end

# commas are added to only the numerator
addcommasrat(s, sep) = addcommas(s, length(s), findfirst( isequal('/'), s )-1, sep)

function checkcommas(s, sep)
    len = length(s)
    for i in len:-1:1
        isdigit( s[i] ) && return addcommas(s, len, i, sep)
    end
    s
end

function addcommas(s::T, len, lst, sep) where {T<:AbstractString}
    lst < 4 && return s
    beg = 1
    while beg < len
        isdigit(s[beg]) && break
        beg += 1
    end
    dig = lst - beg + 1
    dig < 4 && return s

    commas = div(dig - 1, 3)
    sv = Base.StringVector(len + commas)

    for i = 1:beg-1; sv[i] = s[i]; end
    cnt = dig - commas*3
    pos = beg - 1
    for i = beg:lst-3
        sv[pos += 1] = s[i]
        (cnt -= 1) == 0 && (cnt = 3; sv[pos += 1] = sep)
    end
    for i = lst-2:len; sv[i+commas] = s[i]; end
    T(sv)
end
addcommas(s, sep) = (l = length(s); addcommas(s, l, l, sep))

function generate_format_string(;
                                width::Int=-1,
                                precision::Int= -1,
                                leftjustified::Bool=false,
                                zeropadding::Bool=false,
                                commas::Bool=false,
                                signed::Bool=false,
                                positivespace::Bool=false,
                                alternative::Bool=false,
                                conversion::ASCIIStr="f" #aAdecEfFiosxX
                                )
    s = ['%'%UInt8]
    commas &&
        push!(s, '\'')
    alternative && in( conversion[1], "aAeEfFoxX" ) &&
        push!(s, '#')
    zeropadding && !leftjustified && width != -1 &&
        push!(s, '0')
    if signed
        push!(s, '+')
    elseif positivespace
        push!(s, ' ')
    end
    if width != -1
        leftjustified && push!(s, '-')
        append!(s, _codeunits(string( width )))
    end
    precision != -1 &&
        append!(s, _codeunits(string( '.', precision )))
    String(append!(s, _codeunits(conversion)))
end

"""
Format a value, using the following keyword arguments to control formatting
(Bold keywords are not printf standard):

* width. Integer. Try to fit the output into this many characters. May not be successful.
   Sacrifice space first, then commas.
* precision. Integer. How many decimal places.
* leftjustified. Boolean
* zeropadding. Boolean
* commas. Boolean. Thousands-group separator.
* signed. Boolean. Always show +/- sign?
* positivespace. Boolean. Prepend an extra space for positive numbers? (so they align nicely with negative numbers)
* **parens**. Boolean. Use parenthesis instead of "-". e.g. `(1.01)` instead of `-1.01`. Useful in finance. Note that
  you cannot use `signed` and `parens` option at the same time.
* **stripzeros**. Boolean. Strip trailing '0' to the right of the decimal (and to the left of 'e', if any ).
   * It may strip the decimal point itself if all trailing places are zeros.
   * This is true by default if precision is not given, and vice versa.
* alternative. Boolean. See `#` alternative form explanation in standard printf documentation
* conversion. length=1 string. Default is type dependent. It can be one of `aAeEfFoxX`. See standard
  printf documentation.
* **mixedfraction**. Boolean. If the number is rational, format it in mixed fraction e.g. `1_1/2` instead of `3/2`
* **mixedfractionsep**. Default `_`
* **fractionsep**. Default `/`
* **fractionwidth**. Integer. Try to pad zeros to the numerator until the fractional part has this width
* **tryden**. Integer. Try to use this denominator instead of a smaller one. No-op if it'd lose precision.
* **suffix**. String. This strings will be appended to the output. Useful for units/%
* **autoscale**. Symbol, default `:none`. It could be `:metric`, `:binary`, or `:finance`.
    * `:metric` implements common SI symbols for large and small numbers e.g. `M`, `k`, `μ`, `n`
    * `:binary` implements common ISQ symbols for large numbers e.g. `Ti`, `Gi`, `Mi`, `Ki`
    * `:finance` implements common finance/news symbols for large numbers e.g. `b` (billion), `m` (millions)
"""
function format( x::T;
                 width::Int=-1,
                 precision::Int= -1,
                 leftjustified::Bool=false,
                 zeropadding::Bool=false, # when right-justified, use 0 instead of space to fill
                 commas::Bool=false,
                 signed::Bool=false, # +/- prefix
                 positivespace::Bool=false,
                 stripzeros::Bool=(precision== -1),
                 parens::Bool=false, # use (1.00) instead of -1.00. Used in finance
                 alternative::Bool=false, # usually for hex
                 mixedfraction::Bool=false,
                 mixedfractionsep::UTF8Str="_",
                 fractionsep::UTF8Str="/", # num / den
                 fractionwidth::Int = 0,
                 tryden::Int = 0, # if 2 or higher,
                                  # try to use this denominator, without losing precision
                 suffix::UTF8Str="", # useful for units/%
                 autoscale::Symbol=:none, # :metric, :binary or :finance
                 conversion::ASCIIStr=""
                 ) where {T<:Real}
    checkwidth = commas
    if conversion == ""
        if T <: AbstractFloat || T <: Rational && precision != -1
            actualconv = "f"
        elseif T <: Unsigned
            actualconv = "x"
        elseif T <: Integer
            actualconv = "d"
        else
            conversion = "s"
            actualconv = "s"
        end
    else
        actualconv = conversion
    end
    signed && commas && error( "You cannot use signed (+/-) AND commas at the same time")

    T <: Rational && conversion == "s" && (stripzeros = false)
    if ( T <: AbstractFloat && actualconv == "f" || T <: Integer ) && autoscale != :none
        actualconv = "f"
        if autoscale == :metric
            scales = [
                (1e24, "Y" ),
                (1e21, "Z" ),
                (1e18, "E" ),
                (1e15, "P" ),
                (1e12, "T" ),
                (1e9,  "G"),
                (1e6,  "M"),
                (1e3,  "k") ]
            if abs(x) > 1
                for (mag, sym) in scales
                    if abs(x) >= mag
                        x /= mag
                        suffix = string(sym, suffix)
                        break
                    end
                end
            elseif T <: AbstractFloat
                smallscales = [
                    ( 1e-12, "p" ),
                    ( 1e-9,  "n" ),
                    ( 1e-6,  "μ" ),
                    ( 1e-3,  "m" ) ]
                for (mag,sym) in smallscales
                    if abs(x) < mag*10
                        x /= mag
                        suffix = string(sym, suffix)
                        break
                    end
                end
            end
        else
            if autoscale == :binary
                scales = [
                    (1024.0 ^8,  "Yi" ),
                    (1024.0 ^7,  "Zi" ),
                    (1024.0 ^6,  "Ei" ),
                    (1024.0 ^5,  "Pi" ),
                    (1024.0 ^4,  "Ti" ),
                    (1024.0 ^3,  "Gi"),
                    (1024.0 ^2,  "Mi"),
                    (1024.0,     "Ki")
                ]
            else # :finance
                scales = [
                    (1e12, "t" ),
                    (1e9,  "b"),
                    (1e6,  "m"),
                    (1e3,  "k") ]
            end
            for (mag, sym) in scales
                if abs(x) >= mag
                    x /= mag
                    suffix = string(sym, suffix)
                    break
                end
            end
        end
    end

    nonneg = x >= 0
    fractional = 0
    if T <: Rational && mixedfraction
        actualconv = "d"
        actualx = trunc( Int, x )
        fractional = abs(x) - abs(actualx)
    else
        actualx = (parens && !in( actualconv[1], "xX" )) ? abs(x) : x
    end
    s = cfmt( generate_format_string( width=width,
                                      precision=precision,
                                      leftjustified=leftjustified,
                                      zeropadding=zeropadding,
                                      commas=commas,
                                      signed=signed,
                                      positivespace=positivespace,
                                      alternative=alternative,
                                      conversion=actualconv
                                      ),
              actualx)

    if T <:Rational && conversion == "s"
        if mixedfraction && fractional != 0
            num = fractional.num
            den = fractional.den
            if tryden >= 2 && mod( tryden, den ) == 0
                num *= div(tryden,den)
                den = tryden
            end
            fs = string( num, fractionsep, den)
            length(fs) < fractionwidth &&
                (fs = string(repeat( "0", fractionwidth - length(fs) ), fs))
            s = (actualx != 0
                 ? string(rstrip(s), mixedfractionsep, fs)
                 : (nonneg ? fs : string('-', fs)))
            checkwidth = true
        elseif !mixedfraction
            s = replace( s, "//" => fractionsep )
            checkwidth = true
        end
    elseif stripzeros && in( actualconv[1], "fFeEs" )
        dpos = findfirst( isequal('.'), s )
        dpos === nothing && (dpos = length(s))
        if actualconv[1] in "eEs"
            epos = findfirst(isequal(actualconv[1] == 'E' ? 'E' : 'e'), s)
            rpos = (epos === nothing) ? length( s ) : (epos-1)
        else
            rpos = length(s)
        end
        # rpos at this point is the rightmost possible char to start
        # stripping
        stripfrom = rpos+1
        for i = rpos:-1:dpos+1
            if s[i] == '0'
                stripfrom = i
            elseif s[i] ==' '
                continue
            else
                break
            end
        end
        if stripfrom <= rpos
            # everything after decimal is 0, so strip the decimal too
            s = string(s[1:stripfrom-1-(stripfrom == dpos+1)], s[rpos+1:end])
            checkwidth = true
        end
    end

    s = string(s, suffix)

    if parens && !in( actualconv[1], "xX" )
        # if zero or positive, we still need 1 white space on the right
        s = nonneg ? string(' ', strip(s), ' ') : string('(', strip(s), ')')
        checkwidth = true
    end

    if checkwidth && width != -1
        if (len = length(s) - width) > 0
            s = replace( s, " " => ""; count=len )
            if (len = length(s) - width) > 0
                endswith(s, " ") && (s = reverse(replace(reverse(s), " " => ""; count=len)))
                (len = length(s) - width) > 0 && (s = replace( s, "," => ""; count=len ))
            end
        elseif len < 0
            # Todo: should use lpad or rpad here, can be more efficient
            s = leftjustified ? string(s, repeat( " ", -len )) : string(repeat( " ", -len), s)
        end
    end

    s
end

# some basic functionality testing
x = 1234.56789

@test fmt(x) == "1234.567890"
@test fmt(x;prec=2) == "1234.57"
@test fmt(x,10,3) == "  1234.568"
@test fmt(x,10,3,:left) == "1234.568  "
@test fmt(x,10,3,:ljust) == "1234.568  "
@test fmt(x,10,3,:right) == "  1234.568"
@test fmt(x,10,3,:rjust) == "  1234.568"
@test fmt(x,10,3,:center) == " 1234.568 "
@test fmt(x,10,3,:zpad) == "001234.568"
@test fmt(x,10,3,:zeropad) == "001234.568"
@test fmt(x,:commas) == "1,234.567890"
@test fmt(x,10,3,:left,:commas) == "1,234.568 "
@test fmt(x,:ipre) == "1234.567890"
@test fmt(x,12) == " 1234.567890"

i = 1234567

@test fmt(i) == "1234567"
@test fmt(i,:commas) == "1,234,567"

# These are not handled
#@test_throws ErrorException fmt_default(Real)
#@test_throws ErrorException fmt_default(Complex)

fmt_default!(Int, :commas, width = 12)
@test fmt(i) == "   1,234,567"
@test fmt(x) == "1234.567890"  # default hasn't changed

fmt_default!(:commas)
@test fmt(i) == "   1,234,567"
@test fmt(x) == "1,234.567890"  # width hasn't changed, but added commas

fmt_default!(Int) # resets Integer defaults
@test fmt(i) == "1234567"
@test fmt(i,:commas) == "1,234,567"

reset!(Int)
fmt_default!(UInt16, 'd', :commas)
@test fmt(0xffff) == "65,535"
fmt_default!(UInt32, UInt16, width=20)
@test fmt(0xfffff) == "           1,048,575"

# formatting expression

### Argument specification

struct ArgSpec
    argidx::Int
    hasfilter::Bool
    filter::Function

    function ArgSpec(idx::Int, hasfil::Bool, filter::Function)
        idx != 0 || error("Argument index cannot be zero.")
        new(idx, hasfil, filter)
    end
end

getarg(args, sp::ArgSpec) =
    (a = args[sp.argidx]; sp.hasfilter ? sp.filter(a) : a)

# pos > 0: must not have iarg in expression (use pos+1), return (entry, pos + 1)
# pos < 0: must have iarg in expression, return (entry, -1)
# pos = 0: no positional argument before, can be either, return (entry, 1) or (entry, -1)
function make_argspec(s::AbstractString, pos::Int)
    # for argument position
    iarg::Int = -1
    hasfil::Bool = false
    ff::Function = Base.identity

    if !isempty(s)
        filrange = findfirst("|>", s)
        if filrange === nothing
            iarg = parse(Int, s)
        else
            ifil = first(filrange)
            iarg = ifil > 1 ? parse(Int, s[1:prevind(s, ifil)]) : -1
            hasfil = true
            ff = m_eval(Symbol(s[ifil+2:end]))
        end
    end

    if pos > 0
        iarg < 0 || error("entry with and without argument index must not coexist.")
        iarg = (pos += 1)
    elseif pos < 0
        iarg > 0 || error("entry with and without argument index must not coexist.")
    else # pos == 0
        if iarg < 0
            iarg = pos = 1
        else
            pos = -1
        end
    end

    return (ArgSpec(iarg, hasfil, ff), pos)
end


### Format entry

struct FormatEntry
    argspec::ArgSpec
    spec::FormatSpec
end

function make_formatentry(s::AbstractString, pos::Int)
    @assert s[1] == '{' && s[end] == '}'
    sc = s[2:prevind(s, lastindex(s))]
    icolon = findfirst(isequal(':'), sc)
    if icolon === nothing  # no colon
        (argspec, pos) = make_argspec(sc, pos)
        spec = FormatSpec('s')
    else
        (argspec, pos) = make_argspec(sc[1:prevind(sc, icolon)], pos)
        spec = FormatSpec(sc[nextind(sc, icolon):end])
    end
    return (FormatEntry(argspec, spec), pos)
end


### Format expression

mutable struct FormatExpr
    prefix::UTF8Str
    suffix::UTF8Str
    entries::Vector{FormatEntry}
    inter::Vector{UTF8Str}
end

_raise_unmatched_lbrace() = error("Unmatched { in format expression.")

function find_next_entry_open(s::AbstractString, si::Int)
    slen = lastindex(s)
    p = findnext(isequal('{'), s, si)
    (p === nothing || p < slen) || _raise_unmatched_lbrace()
    while p !== nothing && s[p+1] == '{'  # escape `{{`
        p = findnext(isequal('{'), s, p+2)
        (p === nothing || p < slen) || _raise_unmatched_lbrace()
    end
    pre = p !== nothing ? s[si:prevind(s, p)] : s[si:end]
    if !isempty(pre)
        pre = replace(pre, "{{" => '{')
        pre = replace(pre, "}}" => '}')
    end
    return (p, convert(UTF8Str, pre))
end

function find_next_entry_close(s::AbstractString, si::Int)
    p = findnext(isequal('}'), s, si)
    p !== nothing || _raise_unmatched_lbrace()
    return p
end

function FormatExpr(s::AbstractString)
    slen = length(s)

    # init
    prefix = UTF8Str("")
    suffix = UTF8Str("")
    entries = FormatEntry[]
    inter = UTF8Str[]

    # scan
    (p, prefix) = find_next_entry_open(s, 1)
    if p !== nothing
        q = find_next_entry_close(s, p+1)
        (e, pos) = make_formatentry(s[p:q], 0)
        push!(entries, e)
        (p, pre) = find_next_entry_open(s, q+1)
        while p !== nothing
            push!(inter, pre)
            q = find_next_entry_close(s, p+1)
            (e, pos) = make_formatentry(s[p:q], pos)
            push!(entries, e)
            (p, pre) = find_next_entry_open(s, q+1)
        end
        suffix = pre
    end
    FormatExpr(prefix, suffix, entries, inter)
end

function printfmt(io::IO, fe::FormatExpr, args...)
    isempty(fe.prefix) || print(io, fe.prefix)
    ents = fe.entries
    ne = length(ents)
    if ne > 0
        e = ents[1]
        printfmt(io, e.spec, getarg(args, e.argspec))
        for i = 2:ne
            print(io, fe.inter[i-1])
            e = ents[i]
            printfmt(io, e.spec, getarg(args, e.argspec))
        end
    end
    isempty(fe.suffix) || print(io, fe.suffix)
end

const StringOrFE = Union{AbstractString, FormatExpr}
printfmt(io::IO, fe::AbstractString, args...) = printfmt(io, FormatExpr(fe), args...)
printfmt(fe::StringOrFE, args...) = printfmt(_stdout(), fe, args...)

printfmtln(io::IO, fe::StringOrFE, args...) = (printfmt(io, fe, args...); println(io))
printfmtln(fe::StringOrFE, args...) = printfmtln(_stdout(), fe, args...)

format(fe::StringOrFE, args...) = sprint(printfmt, fe, args...)

"""
Format.jl

This package provides various functions to provide formatted output,
either in a fashion similar to C printf or Python format strings.

## Python-style Types and Functions

#### Types to Represent Formats

This package has two types ``FormatSpec`` and ``FormatExpr`` to represent a format specification.

In particular, ``FormatSpec`` is used to capture the specification of a single entry. One can compile a format specification string into a ``FormatSpec`` instance as

```julia
fspec = FormatSpec("d")
fspec = FormatSpec("<8.4f")
```
Please refer to [Python's format specification language](http://docs.python.org/2/library/string.html#formatspec) for details.


``FormatExpr`` captures a formatting expression that may involve multiple items. One can compile a formatting string into a ``FormatExpr`` instance as

```julia
fe = FormatExpr("{1} + {2}")
fe = FormatExpr("{1:d} + {2:08.4e} + {3|>abs2}")
```
Please refer to [Python's format string syntax](http://docs.python.org/2/library/string.html#format-string-syntax) for details.


**Note:** If the same format is going to be applied for multiple times. It is more efficient to first compile it.


#### Formatted Printing

One can use ``printfmt`` and ``printfmtln`` for formatted printing:

- **printfmt**(io, fe, args...)

- **printfmt**(fe, args...)

    Print given arguments using given format ``fe``. Here ``fe`` can be a formatting string, an instance of ``FormatSpec`` or ``FormatExpr``.
    
    **Examples**
    
    ```julia
    printfmt("{1:>4s} + {2:.2f}", "abc", 12) # --> print(" abc + 12.00")
    printfmt("{} = {:#04x}", "abc", 12) # --> print("abc = 0x0c") 
    
    fs = FormatSpec("#04x")
    printfmt(fs, 12)   # --> print("0x0c")
    
    fe = FormatExpr("{} = {:#04x}")
    printfmt(fe, "abc", 12)   # --> print("abc = 0x0c")
    ```

    **Notes**

    If the first argument is a string, it will be first compiled into a ``FormatExpr``, which implies that you can not use specification-only string in the first argument.

    ```julia
    printfmt("{1:d}", 10)   # OK, "{1:d}" can be compiled into a FormatExpr instance
    printfmt("d", 10)       # Error, "d" can not be compiled into a FormatExpr instance
                            # such a string to specify a format specification for single argument

    printfmt(FormatSpec("d"), 10)  # OK
    printfmt(FormatExpr("{1:d}", 10)) # OK
    ```


- **printfmtln**(io, fe, args...)

- **printfmtln**(fe, args...)

    Similar to ``printfmt`` except that this function print a newline at the end.

#### Formatted String

One can use ``pyfmt`` to format a single value into a string, or ``format`` to format one to multiple arguments into a string using an format expression.

- **pyfmt**(fspec, a)

    Format a single value using a format specification given by ``fspec``, where ``fspec`` can be either a string or an instance of ``FormatSpec``.

- **format**(fe, args...)

    Format arguments using a format expression given by ``fe``, where ``fe`` can be either a string or an instance of ``FormatSpec``.


#### Difference from Python's Format

At this point, this package implements a subset of Python's formatting language (with slight modification). Here is a summary of the differences:

- In terms of argument specification, it supports natural ordering (e.g. ``{} + {}``), explicit position (e.g. ``{1} + {2}``). It hasn't supported named arguments or fields extraction yet. Note that mixing these two modes is not allowed (e.g. ``{1} + {}``).

- The package provides support for filtering (for explicitly positioned arguments), such as ``{1|>lowercase}`` by allowing one to embed the ``|>`` operator, which the Python counter part does not support.

## C-style functions

The c-style part of this package aims to get around the limitation that
`@sprintf` has to take a literal string argument.
The core part is basically a c-style print formatter using the standard
`@sprintf` macro.
It also adds functionalities such as commas separator (thousands), parenthesis for negatives,
stripping trailing zeros, and mixed fractions.

### Usage and Implementation

The idea here is that the package compiles a function only once for each unique
format string within the `Format.*` name space, so repeated use is faster.
Unrelated parts of a session using the same format string would reuse the same
function, avoiding redundant compilation. To avoid the proliferation of
functions, we limit the usage to only 1 argument. Practical consideration
would suggest that only dozens of functions would be created in a session, which
seems manageable.

Usage
```julia
using Format

fmt = "%10.3f"
s = cfmt( fmt, 3.14159 ) # usage 1. Quite performant. Easiest to switch to.

fmtrfunc = generate_formatter( fmt ) # usage 2. This bypasses repeated lookup of cached function. Most performant.
s = fmtrfunc( 3.14159 )

s = format( 3.14159, precision=3 ) # usage 3. Most flexible, with some non-printf options. Least performant.
```
### Commas

This package also supplements the lack of thousand separator e.g. `"%'d"`, `"%'f"`, `"%'g"`.

Note: `"%'g"` behavior is that for small enough floating point (but not too small),
thousand separator would be used. If the number needs to be represented by `"%e"`, no
separator is used.

### Flexible `format` function

This package contains a run-time number formatter `format` function, which goes beyond
the standard `sprintf` functionality.

An example:
```julia
s = format( 1234, commas=true ) # 1,234
s = format( -1234, commas=true, parens=true ) # (1,234)
```

The keyword arguments are (Bold keywards are not printf standard)

* width. Integer. Try to fit the output into this many characters. May not be successful.
   Sacrifice space first, then commas.
* precision. Integer. How many decimal places.
* leftjustified. Boolean
* zeropadding. Boolean
* commas. Boolean. Thousands-group separator.
* signed. Boolean. Always show +/- sign?
* positivespace. Boolean. Prepend an extra space for positive numbers? (so they align nicely with negative numbers)
* **parens**. Boolean. Use parenthesis instead of "-". e.g. `(1.01)` instead of `-1.01`. Useful in finance. Note that
  you cannot use `signed` and `parens` option at the same time.
* **stripzeros**. Boolean. Strip trailing '0' to the right of the decimal (and to the left of 'e', if any ).
   * It may strip the decimal point itself if all trailing places are zeros.
   * This is true by default if precision is not given, and vice versa.
* alternative. Boolean. See `#` alternative form explanation in standard printf documentation
* conversion. length=1 string. Default is type dependent. It can be one of `aAeEfFoxX`. See standard
  printf documentation.
* **mixedfraction**. Boolean. If the number is rational, format it in mixed fraction e.g. `1_1/2` instead of `3/2`
* **mixedfractionsep**. Default `_`
* **fractionsep**. Default `/`
* **fractionwidth**. Integer. Try to pad zeros to the numerator until the fractional part has this width
* **tryden**. Integer. Try to use this denominator instead of a smaller one. No-op if it'd lose precision.
* **suffix**. String. This strings will be appended to the output. Useful for units/%
* **autoscale**. Symbol, default `:none`. It could be `:metric`, `:binary`, or `:finance`.
    * `:metric` implements common SI symbols for large and small numbers e.g. `M`, `k`, `μ`, `n`
    * `:binary` implements common ISQ symbols for large numbers e.g. `Ti`, `Gi`, `Mi`, `Ki`
    * `:finance` implements common finance/news symbols for large numbers e.g. `b` (billion), `m` (millions)
"""
module Format

import Base.show

_stdout() = stdout
_codeunits(s) = Vector{UInt8}(codeunits(s))
m_eval(expr) = Core.eval(@__MODULE__, expr)

export FormatSpec, FormatExpr, printfmt, printfmtln, format, generate_formatter
export pyfmt, cfmt, fmt
export fmt_default, fmt_default!, reset!, default_spec, default_spec!

# Deal with mess from #16058
# Later, use Strs package!
isdefined(Main, :ASCIIStr) || (const ASCIIStr = String)
isdefined(Main, :UTF8Str)  || (const UTF8Str = String)

include("cformat.jl" )
include("fmtspec.jl")
include("fmtcore.jl")
include("formatexpr.jl")
include("fmt.jl")

end # module Format

# performance testing

using Format

# performance of format parsing

fp1() = FormatExpr("{1} + {2} + {3}")

fp1()
@time for i=1:10000; fp1(); end

fp2() = FormatExpr("abc {1:*<5d} efg {2:*>8.4e} hij")

fp2()
@time for i=1:10000; fp2(); end

# performance of string formatting

const fe1 = fp1()
const fe2 = fp2()

sf1(x, y, z) = format(fe1, x, y, z)
sf1(10, 20, 30)
@time for i=1:10000; sf1(10, 20, 30); end

sf2(x, y) = format(fe2, x, y)
sf2(10, 20)
@time for i=1:10000; sf2(10, 20); end

# formatting specification

# formatting specification language
#
#  spec  ::= [[fill]align][sign][#][0][width][,_][.prec][type]
#  fill  ::= <any character>
#  align ::= '<' | '^' | '>'
#  sign  ::= '+' | '-' | ' '
#  width ::= <integer>
#  prec  ::= <integer>
#  type  ::= 'b' | 'c' | 'd' | 'e' | 'E' | 'f' | 'F' | 'g' | 'G' |
#            'n' | 'o' | 'x' | 'X' | 's' | '%'
#
# Please refer to http://docs.python.org/2/library/string.html#formatspec
# for more details
#

## FormatSpec type

const _numtypchars = Set(['b', 'd', 'e', 'E', 'f', 'F', 'g', 'G', 'n', 'o', 'x', 'X', '%'])

_tycls(c::AbstractChar) =
    (c == 'd' || c == 'n' || c == 'b' || c == 'o' || c == 'x') ? 'i' :
    (c == 'e' || c == 'f' || c == 'g' || c == '%') ? 'f' :
    (c == 'c') ? 'c' :
    (c == 's') ? 's' :
    error("Invalid type char $(c)")

struct FormatSpec
    cls::Char    # category: 'i' | 'f' | 'c' | 's'
    typ::Char
    fill::Char
    align::Char
    sign::Char
    width::Int
    prec::Int
    ipre::Bool   # whether to prefix 0b, 0o, or 0x
    zpad::Bool   # whether to do zero-padding
    tsep::Bool   # whether to use thousand-separator
    sep::Char

    function FormatSpec(typ::AbstractChar;
                        fill::AbstractChar=' ',
                        align::AbstractChar='\0',
                        sign::AbstractChar='-',
                        width::Int=-1,
                        prec::Int=-1,
                        ipre::Bool=false,
                        zpad::Bool=false,
                        tsep=nothing)

        align == '\0' && (align = (typ in _numtypchars) ? '>' : '<')
        cls = _tycls(lowercase(typ))
        cls == 'f' && prec < 0 && (prec = 6)
        if tsep === true
            sep = ','
        elseif tsep isa AbstractChar
            sep = Char(tsep)
            tsep = true
        else
            sep = '\0'
            tsep = false
        end
        new(cls, Char(typ), Char(fill), Char(align), Char(sign), width, prec, ipre, zpad,
            tsep, sep)
    end

    # copy constructor with overrides
    function FormatSpec(spec::FormatSpec;
                        fill::AbstractChar=spec.fill,
                        align::AbstractChar=spec.align,
                        sign::AbstractChar=spec.sign,
                        width::Int=spec.width,
                        prec::Int=spec.prec,
                        ipre::Bool=spec.ipre,
                        zpad::Bool=spec.zpad,
                        tsep=nothing)
        if tsep === nothing
            tsep = spec.tsep
            sep = spec.sep
        elseif tsep === true
            sep = ','
        elseif tsep isa AbstractChar
            sep = Char(tsep)
            tsep = true
        else
            sep = '\0'
            tsep = false
        end
        new(spec.cls, spec.typ, Char(fill), Char(align), Char(sign), width, prec, ipre, zpad,
            tsep, sep)
    end
end

function show(io::IO, fs::FormatSpec)
    println(io, typeof(fs))
    println(io, "  cls   = ", fs.cls)
    println(io, "  typ   = ", fs.typ)
    println(io, "  fill  = ", fs.fill)
    println(io, "  align = ", fs.align)
    println(io, "  sign  = ", fs.sign)
    println(io, "  width = ", fs.width)
    println(io, "  prec  = ", fs.prec)
    println(io, "  ipre  = ", fs.ipre)
    println(io, "  zpad  = ", fs.zpad)
    println(io, "  tsep  = ", fs.tsep ? repr(fs.sep) : "false")
end

## parse FormatSpec from a string

const _spec_regex = r"^(.?[<^>])?([ +-])?(#)?(\d+)?([,_])?(.\d+)?([bcdeEfFgGnosxX%])?$"

function FormatSpec(s::AbstractString)
    # default spec
    _fill = ' '
    _align = '\0'
    _sign = '-'
    _width = -1
    _prec = -1
    _ipre = false
    _zpad = false
    _tsep = false
    
    _typ = 's'

    if !isempty(s)
        m = match(_spec_regex, s)
        m == nothing && error("Invalid formatting spec: $(s)")

        (a1, a2, a3, a4, a5, a6, a7) = m.captures

        # a1: [[fill]align]
        if a1 != nothing
            if length(a1) == 1
                _align = a1[1]
            else
                _fill = a1[1]
                _align = a1[nextind(a1, 1)]
            end
        end

        # a2: [sign]
        a2 == nothing || (_sign = a2[1])

        # a3: [#]
        a3 == nothing || (_ipre = true)

        # a4: [0][width]
        if a4 != nothing
            if a4[1] == '0'
                _zpad = true
                length(a4) > 1 && (_width = parse(Int, a4[2:end]))
            else
                _width = parse(Int, a4)
            end
        end

        # a5: [,_]
        a5 == nothing || (_tsep = a5[1])

        # a6 [.prec]
        a6 == nothing || (_prec = parse(Int, a6[2:end]))

        # a7: [type]
        a7 == nothing || (_typ = a7[1])
    end

    FormatSpec(_typ;
               fill=_fill,
               align=_align,
               sign=_sign,
               width=_width,
               prec=_prec,
               ipre=_ipre,
               zpad=_zpad,
               tsep=_tsep)
end # function FormatSpec


## formatted printing using a format spec

struct _Dec end
struct _Oct end
struct _Hex end
struct _HEX end
struct _Bin end

_srepr(x) = repr(x)
_srepr(x::AbstractString) = x
_srepr(x::Symbol) = string(x)
_srepr(x::AbstractChar) = string(x)
_srepr(x::Enum) = string(x)

function printfmt(io::IO, fs::FormatSpec, x)
    cls = fs.cls
    ty = fs.typ
    if cls == 'i'
        ix = Integer(x)
        ty == 'd' || ty == 'n' ? _pfmt_i(io, fs, ix, _Dec()) :
        ty == 'x' ? _pfmt_i(io, fs, ix, _Hex()) :
        ty == 'X' ? _pfmt_i(io, fs, ix, _HEX()) :
        ty == 'o' ? _pfmt_i(io, fs, ix, _Oct()) :
        _pfmt_i(io, fs, ix, _Bin())
    elseif cls == 'f'
        fx = float(x)
        if isfinite(fx)
            ty == 'f' || ty == 'F' || ty == '%' ? _pfmt_f(io, fs, fx) :
            ty == 'e' || ty == 'E' ? _pfmt_e(io, fs, fx) : _pfmt_g(io, fs, fx)
        else
            _pfmt_specialf(io, fs, fx)
        end
    elseif cls == 's'
        _pfmt_s(io, fs, _srepr(x))
    else # cls == 'c'
        _pfmt_s(io, fs, Char(x))
    end
end

printfmt(fs::FormatSpec, x) = printfmt(_stdout(), fs, x)

pyfmt(fs::FormatSpec, x) = (buf = IOBuffer(); printfmt(buf, fs, x); String(take!(buf)))
pyfmt(spec::AbstractString, x) = pyfmt(FormatSpec(spec), x)

println( "\nTest speed" )

const BENCH_REP = 200_000

function native_int()
    for i in 1:BENCH_REP
        @sprintf( "%10d", i )
    end
end
@static if VERSION >= v"1.6"
function format_int()
    fmt = Printf.Format( "%10d" )
    for i in 1:BENCH_REP
        Printf.format( fmt, i )
    end
end
end
function runtime_int()
    for i in 1:BENCH_REP
        cfmt( "%10d", i )
    end
end
function runtime_int_spec()
    fs = Format.FmtSpec("%10d")
    for i in 1:BENCH_REP
        cfmt( fs, i )
    end
end
function runtime_int_bypass()
    f = generate_formatter( "%10d" )
    for i in 1:BENCH_REP
        f( i )
    end
end

println( "integer @sprintf speed")
@time native_int()
@static if VERSION >= v"1.6"
    println( "integer format speed")
    @time format_int()
end
println( "integer cfmt speed")
@time runtime_int()
println( "integer cfmt spec speed")
@time runtime_int_spec()
println( "integer cfmt speed, bypass repeated lookup")
@time runtime_int_bypass()

set_seed!(10)
const testflts = [ _erfinv( rand() ) for i in 1:200_000 ]

function native_float()
    for v in testflts
        @sprintf( "%10.4f", v)
    end
end
@static if VERSION >= v"1.6"
function format_float()
    fmt = Printf.Format( "%10.4f" )
    for v in testflts
        Printf.format( fmt, v )
    end
end
end
function runtime_float()
    for v in testflts
        cfmt( "%10.4f", v)
    end
end
function runtime_float_spec()
    fs = Format.FmtSpec("%10.4f")
    for v in testflts
        cfmt( fs, v )
    end
end
function runtime_float_bypass()
    f = generate_formatter( "%10.4f" )
    for v in testflts
        f( v )
    end
end

println()
println( "float64 @sprintf speed")
@time native_float()
@static if VERSION >= v"1.6"
println( "float64 format speed")
@time format_float()
end
println( "float64 cfmt speed")
@time runtime_float()
println( "float64 cfmt spec speed")
@time runtime_float_spec()
println( "float64 cfmt speed, bypass repeated lookup")
@time runtime_float_bypass()

using Format
using Test
using Printf
using Random

@testset "cformat"    begin include( "cformat.jl" ) end
@testset "printf"     begin include( "printf.jl" ) end
@testset "fmtspec"    begin include( "fmtspec.jl" ) end
@testset "formatexpr" begin include( "formatexpr.jl" ) end
@testset "fmt"        begin include( "fmt.jl" ) end
